// ISRRX and ISRRX2 example
device = 18F27J13
clock = 32

include "intosc.bas"
#option DIGITALIO_INIT = true   // automatically call SetAllDigital at startup
include "setdigitalio.bas"
include "pps.bas"

// 27J13 (VDD=3V3, 5V tol pins)
// TX1  RC6/RP17
// RX1  RC7/RP18
// TX2  RC4/RP15 (PPS)
// RX2  RC5/RP16 (PPS)

//
// If you are using a device with PPS mapped pins then set the #options
// 'USARTx_TX' and 'USARTx_RX' to match the port pins you're using before
// including the USARTx.bas module... you'll still have to setup the PPS
// NOTE: if the pins have analog capability it is up to the user to set 
// the respective pins to digital IO mode (ie setalldigital)
//

// ISRRX setup
// select USARTx and import library...
#option USART_TX = PORTC.6         // usart TX output
#option USART_RX = PORTC.7         // usart RX input
include "USART.bas"

#option RX_USART_SELECT = 1
#option RX_BUFFER_SIZE = 32
#option RX_PRIORITY = ipHigh
include "ISRRX.bas"

// ISRRX2 setup
// select USARTx and import library...
#option USART2_TX = PORTC.4         // usart2 TX output (pps mapped)
#option USART2_RX = PORTC.5         // usart2 RX input (pps mapped)
include "USART2.bas"

#option RX2_USART_SELECT = 2
#option RX2_BUFFER_SIZE = 32
#option RX2_PRIORITY = ipLow
include "ISRRX2.bas"

dim rxc as byte

// assign uart2 pps pins (18F27J13)
pps.unlock()
pps.assign_output(PPS_TX2, PPS_OUT_RP15)     // PORTC.4
pps.assign_input(PPS_RX2, PPS_IN_RP16)       // PORTC.5

// ISRRX (uart1)
USART.SetBaudrate(br115200)
ISRRX.Initialize()
// ISRRX2 (uart2)
USART2.SetBaudrate(br115200)
ISRRX2.Initialize()

// loop forever...
while true
   // report an error...
   if ISRRX.Overrun() then
      ISRRX.Reset()
   endif

   // read data from the buffer...
   while ISRRX.DataAvailable()
      rxc = ISRRX.ReadByte()
   end while

   // report an error...
   if ISRRX2.Overrun() then
      ISRRX2.Reset()
   endif

   // read data from the buffer...
   while ISRRX2.DataAvailable()
      rxc = ISRRX2.ReadByte()
   end while
end while


